package eu.mhsl.minenet.minigames.instance.game;

import eu.mhsl.minenet.minigames.instance.game.minigame.config.GameFactory;
import eu.mhsl.minenet.minigames.instance.game.minigame.types.deathcube.DeathcubeFactory;
import eu.mhsl.minenet.minigames.instance.game.minigame.types.minerun.MinerunFactory;
import eu.mhsl.minenet.minigames.instance.game.minigame.types.stickfight.StickFightFactory;
import eu.mhsl.minenet.minigames.instance.game.minigame.types.trafficlightrace.TrafficLightRaceFactory;

public enum GameList {
    DEATHCUBE(new DeathcubeFactory(), GameType.OTHER),
    STICKFIGHT(new StickFightFactory(), GameType.PVP),
    MINERUN(new MinerunFactory(), GameType.PVE),
    TRAFFICLIGHTRACE(new TrafficLightRaceFactory(), GameType.OTHER);

    private final GameFactory factory;
    private final GameType type;
    GameList(GameFactory factory, GameType type) {
        this.factory = factory;
        this.type = type;
    }
    public GameFactory getFactory() {
        return this.factory;
    }

    public GameType getType() {
        return type;
    }
}
