package eu.mhsl.minenet.minigames.instance.game.minigame.config;

import eu.mhsl.minenet.minigames.instance.game.minigame.Minigame;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.restriction.RestrictionHandler;
import eu.mhsl.minenet.minigames.message.component.TranslatedComponent;
import net.minestom.server.item.Material;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public interface GameFactory {
    TranslatedComponent name();
    ConfigManager configuration();
    default RestrictionHandler globalRestrictions() {
        return new RestrictionHandler();
    }

    default Material symbol() {
        return Material.GRASS_BLOCK;
    }
    default TranslatedComponent description() {
        return TranslatedComponent.byId("GameFactory#missingDescription");
    }

    Minigame manufacture(Map<String, Option<?>> configuration);

    default Minigame manufacture(List<Option<?>> configuration) {
        if(configuration == null) return manufacture();

        Map<String, Option<?>> cnf = new HashMap<>();
        configuration.forEach(option -> cnf.put(option.getId(), option));

        return manufacture(cnf);
    }

    default Minigame manufacture() {
        if(this.configuration() == null) return manufacture(List.of());

        return manufacture(this.configuration().getAll());
    }
}
